/*
****************************************************************************
****************************************************************************
**                                                                        **
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIAYSTOK 2014                               **
**                                                                        **
**                         Home Control System                            **
**                                                                        **
**                              HC_KEY1                                   **
**                      Wersja z dnia : 2018.06.29                        **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/



#include "key1eeprom.h"
#include <inttypes.h>
#include <avr/pgmspace.h>

#define null 0

EEPROMBlockDataRecT EEBlock ;

uint8_t ChOnCommand [ ] PROGMEM               = "CHON" ;
uint8_t ChOffCommand [ ] PROGMEM              = "CHOFF" ;
uint8_t ChInvCommand [ ] PROGMEM              = "CHINV" ;
uint8_t ChPulseOnCommand [ ] PROGMEM          = "CHPON" ;
uint8_t ChPulseOffCommand [ ] PROGMEM         = "CHPOFF" ;
uint8_t ChLongPulseOnCommand [ ] PROGMEM      = "CHLPON" ;
uint8_t ChLongPulseOffCommand [ ] PROGMEM     = "CHLPOFF" ;

static uint8_t MyDefaultID [ ] PROGMEM               = "KEY1" ;



static void EEPROMClearBlock ( void *   Destination ,
                               uint16_t Size )
{
  uint16_t Loop ;
  uint8_t * Dst ;
  /*----------------------------------------------------------------*/
  Dst = ( uint8_t * ) Destination ;
  for ( Loop = 0 ; Loop < Size ; Loop ++ )
    * Dst ++ = null ;
} /* EEPROMClearBlock */


static void SetIDFlash ( uint8_t * DeviceID , 
                         uint16_t  String )
{
  uint8_t Data ;
  uint8_t Loop ;
  uint8_t * DestCh ;
  /*----------------------------------------------------------------*/
  DestCh = DeviceID ;
  for ( Loop = 0 ; Loop <= DeviceIDSize ; Loop ++ )
    * DestCh ++ = null ;
  DestCh = DeviceID ;
  for ( Loop = 0 ; Loop < DeviceIDSize ; Loop ++ )
  {
    Data = pgm_read_byte_near ( String ++ ) ;
    if ( Data )
      * DestCh ++ = Data ;
    else
      break ;
  } /* for */ ;
} /* SetIDFlash */


void SetDefaultEEBlock ( void )
{
  /*----------------------------------------------------------------*/
  EEPROMClearBlock ( & EEBlock , sizeof ( EEPROMBlockDataRecT ) ) ;
  EEBlock . EEBlockMetric = StandardSygnature ;
  SetIDFlash ( EEBlock . MyDeviceID , ( uint16_t ) MyDefaultID ) ;
  EEBlock . Password [ 0 ] = 'M' ;
  EEBlock . Password [ 1 ] = 'A' ;
  EEBlock . Password [ 2 ] = 'G' ;
  EEBlock . Password [ 3 ] = 'I' ;
  EEBlock . Password [ 4 ] = 'C' ;
  EEBlock . Password [ 5 ] = null ;
  SetIDFlash ( EEBlock . KeyStartService . CommandText , ( uint16_t ) ChOnCommand ) ;
  EEBlock . KeyStartService . ParamValue = 0 ;
  SetIDFlash ( EEBlock . KeyStopService . CommandText , ( uint16_t ) ChOffCommand ) ;
  EEBlock . KeyStopService . ParamValue = 0 ;
  EEBlock . CRCValue = 0 ;
} /* SetDefaultEEBlock */

